/* lexer.l */

%{
#include "par_cnf_types.h"
#include <stdlib.h>
#include <string.h>

extern int lineno;
%}
ws        [ \t\0]+


comment #.*

nl     \n

double	-?[0-9]+.[0-9]+
integer	-?[0-9]+
qstring	\"[^"n]*\"

%%


{nl}          { lineno++; } 
{ws}          ;

TASK_DONE  { return TYPE_TASK_DONE; } 
TASK_NOT_READY  { return TYPE_TASK_NOT_READY; } 
TASK_READY  { return TYPE_TASK_READY; } 
TASK_RUNNING  { return TYPE_TASK_RUNNING; } 
TASK_WAITING  { return TYPE_TASK_WAITING; } 
d  { return TYPE_d; } 
end  { return TYPE_end; } 
id  { return TYPE_id; } 
include_file  { return TYPE_include_file; } 
max_len  { return TYPE_max_len; } 
max_msgs  { return TYPE_max_msgs; } 
name  { return TYPE_name; } 
path  { return TYPE_path; } 
priority  { return TYPE_priority; } 
queue  { return TYPE_queue; } 
state  { return TYPE_state; } 
task  { return TYPE_task; } 
{double}  { return TYPE_double; }
{integer}  { return TYPE_integer; }
{qstring}  { return TYPE_qstring; }

%%
#include <stdio.h>
#include "par.h"
int lineno = 0;
void yyerror (char *err)
{
  printf ("LEXERR: %s lineno %d line %s",err,lineno,yytext);
}
int yywrap ()
{
return 1;
}
int par_cnf_lex (PAR *par)
{
yyin = par->fd;
par->type = yylex();
strcpy (par->symbol, yytext);
return par->type;
}
