/* par_log_main.c */ 
/* DANTE STUB EDIT AS REQUIRED. */
#include "par.h"
/* Maximum size of a symbol or string. */
const int symbol_limit = 1023; 
extern char *optarg;
extern int optind;
int main (int no_args, char *args[])
{
	PAR  st_par;
	PAR  *par= &st_par;
	int c;
	int aflag = 0;
	int bflag = 0;
	char *filename;

 while ((c = getopt (no_args, args, "ab")) != EOF)
    switch (c)
      {      
      case 'a':
        aflag = 1;
        break;
      case 'b':
        bflag = 1;
        break;     
      case '?':
        exit (1);
        break;
      }
     if (args[optind] == 0)
     {
      printf ("USAGE:par [-a - b] file.");
      printf ("Input file was not specified.");
      exit (1);
     } 
	filename = args[optind];

	/* Initialize par structure. */
	par_log_init(par, symbol_limit);

	par->print_lexout = aflag;
	par->print_input = bflag;
	/* Initialize action routines. */
	par_log_act(par);

	/* For file input. */
	par_log_file(par, filename);
	
	printf ("PREFIX TREE:\n");
	pr_tree_prefix (top());
	
	printf ("INFIX TREE:\n");
        pr_tree_infix (top());
        
        printf ("POSTFIX TREE:\n");
        pr_tree_postfix (top());

	if (!par->error_flag)
	     return 0;
	else return 1;
}
