/* par_dan_code.c */
/*
   Copyright (C) 2006 John W. Jordan
   All Rights Reserved
*/
/* 
  This file is part of Dante.
  Dante is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the license, or
  ( at your option ) any later version.
  Dante is distributed in the hope that it will be usefull,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A OARTICULAR PURPOSE. See the
  GNU General Public License for more detaile.
  You should have received a copy of the GNU General Public License
  along with Dante; if not write to the Free Software
  Foundation. Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301
USA
*/
/* This handles actions.
Its an alternative to creating code
nodes and modifing them later on.
Instead it attaches code as attributes of 
terminal and rule nodes.
*/
#include "par.h"
#include <ctype.h>
/* --------------------------------------------------------- */
static void add_code (LINK *list[1], char *symbol);
static const int debug = 0;
/* --------------------------------------------------------- */
int
par_a_bstr (PAR * par)
{
   add_code (par->last_node->action, par->symbol);   
  if (debug)
    printf ("BSTR:ATTACH TO [%s] code {%s}\n", par->last_node->name, par->symbol);
  return 1;
}

/* --------------------------------------------------------- */
/* Processes a function reference defined by @ */
int
par_a_fref (PAR * par)
{ 
   add_code (par->last_node->fun_ref, par->symbol);   
  if (debug)
    printf ("@ [%s] <-- {%s}\n", par->last_node->name, par->symbol);
  return 1;
}

/* --------------------------------------------------------- */
/* Attaches a code reference.*/
/* Last node was the last node allocated. */
int
par_a_cref (PAR * par)
{
  add_code (par->last_node->code_ref, par->symbol);  
  if (debug)
    printf ("CREF: [%s] <-- {%s}\n", par->last_node->name, par->symbol);
  return 1;
}
/* --------------------------------------------------------- */
static void add_code (LINK *list[1], char *symbol)
{
      LINK *new;
      LINK *last_link;
      
     new = (LINK *)xmalloc(sizeof(LINK));
     new->next = 0;
     new->sym = strdup(symbol);
          
     /* Is list empty? */     
     if (list[0] == 0)
     {
         list[0] = new;
         return;
      }     
     /* Go to end of list. */
     for (last_link = list[0]; last_link->next; last_link = last_link->next) ;
     /* Add new link to end. */   
     last_link->next = new;      
}
