/* par_gen_mk.c */
/*
   Copyright (C) 2006 John W. Jordan
   All Rights Reserved
*/
/* 
  This file is part of Dante.
  Dante is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the license, or
  ( at your option ) any later version.
  Dante is distributed in the hope that it will be usefull,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A OARTICULAR PURPOSE. See the
  GNU General Public License for more detaile.
  You should have received a copy of the GNU General Public License
  along with Dante; if not write to the Free Software
  Foundation. Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301
USA
*/
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "par.h"

/* ------------------------------------------------------ */
void
par_gen_mk (PAR * par)
{
  FILE *fd;
  char filename[32];
  char procname[32];
  char *pname;
  
  pname = par->pname;
  strcpy (filename, pname);
  strcat (filename, ".mk");
  strcpy (procname, pname);

  fd = fopen (filename, "w");
  if (!fd)
    {
      printf ("Could not open file %s \n", filename);
      perror ("xxx_gen_mk");
      exit (1);
    }
  fprintf (fd, "CFLAGS = -g  \n\n\n");
  fprintf (fd, "LIBDIR = /usr/local/lib  \n\n\n");
  fprintf (fd, ".SUFFIXES: .dan\n"); 
  fprintf (fd, ".dan.c:\n"); 
  fprintf (fd, "	dante $<\n");
  fprintf (fd, "OBJ =\tpar_%s_main.o\\\n", pname);
  fprintf (fd, "\tpar_%s_file.o\\\n", pname);
  fprintf (fd, "\tpar_%s.o\\\n", pname);
  fprintf (fd, "\tpar_%s_lex.o\\\n", pname);
  fprintf (fd, "\tpar_%s_lex_error.o\\\n", pname);
  fprintf (fd, "\tpar_%s_init.o\\\n", pname);
  fprintf (fd, "\tpar_%s_error.o\\\n", pname);
   
  if (par->gen_flex)
    fprintf (fd, "\tlex.yy.o\\\n", pname);
  
  fprintf (fd, "\tpar_%s_rwtbl.o\\\n", pname);
 
  fprintf (fd, "\tpar_%s_act.o\\\n", pname);
  fprintf (fd, "\tpar_lex_operator.o\n");
  fprintf (fd, "\n\n");
  fprintf (fd, "par: $(OBJ) \n");
  fprintf (fd, "\tcc $(CFLAGS) $(OBJ) -o par_%s ", pname);
  fprintf (fd, "-L/usr/local/lib -ldanpar \n");
  fprintf (fd, "all: \n");
  
  if (par->gen_flex)
    fprintf (fd, "\tflex %s_flex.l\n", pname);

  fprintf (fd, "\tmake par\n\n");
  fprintf (fd, "\tmake clean\n");

  fprintf (fd, "clean: \n");
  fprintf (fd, "\trm -f core \n");
  fprintf (fd, "\trm -f *.o \n");

  fclose (fd);
}
